/*
 * I Mistrzostwa Wielkopolski w Programowaniu Zespoowym
 * Rozwiazanie wzorcowe do zadania A - Funkcja
 * Autor: Bartosz Nowierski
 * Poznan, 2003
 */

#define NDEBUG

#include <stdio.h>
#include <assert.h>

#define MAXLEN 100000
#define MAXSUM 500000
#define MAXN 10000

char str[MAXLEN+3];
int A[MAXN];
int K[MAXN];
int N;



int pos;
int bit;
int val;


int decode()
{
  int cnt;
  int b;
  
  cnt = 0;
  while (1)
  {
    if (0 == bit)
    {
      bit = 4;
      pos--;
      if (pos >= 0)
      {
        assert(((str[pos] >= '0') && (str[pos] <= '9')) ||
          ((str[pos] >= 'A') && (str[pos] <= 'F')));
        if (str[pos] >= 'A')
          val = str[pos]-'A'+10;
        else
          val = str[pos]-'0';
        assert((val >= 0) && (val < 16));
      }
      else
        val = 0;
    }

    b = val&1;
    val >>= 1;
    bit--;
    if (b)
      cnt++;
    else
      break;
  }
  return cnt;
}

int decodelast()
{
  int value, v;
  int shift;
  
  assert((pos-1)*4+bit <= 31);
  value = val;
  shift = bit;
  for (pos--; pos >= 0; pos--)
  {
    assert(((str[pos] >= '0') && (str[pos] <= '9')) ||
      ((str[pos] >= 'A') && (str[pos] <= 'F')));
    if (str[pos] >= 'A')
      v = str[pos]-'A'+10;
    else
      v = str[pos]-'0';
    assert((v >= 0) && (v < 16));
    value |= v<<shift;
    shift += 4;
    assert(shift <= 31);
  }

  return value;
}


int nonzero;

#define shift(b)             \
do                           \
{                            \
  val <<= 1;                 \
  val |= b;                  \
  if (++bit == 4)            \
  {                          \
    if (nonzero || val > 0)  \
    {                        \
      if (val < 10)          \
        putchar(val+'0');    \
      else                   \
        putchar(val-10+'A'); \
      nonzero = 1;           \
    }                        \
    bit = 0;                 \
    val = 0;                 \
  }                          \
} while (0)                  \


void encode(int value)
{
  int i;
  
  for (i = 0; i < value; i++)
  {
  }
}


int main()
{
  int d;
  int len;
  int sum;
  int i;


  if (scanf("%d", &d) < 1)
    assert(0);
  while (d--)
  {
    if (scanf("%d", &N) < 1)
      assert(0);
    assert((N >= 2) && (N <= MAXN));
    if (scanf("%s", str) < 1)
      assert(0);
    len = strlen(str);
    while (str[len-1] == '\n')
      --len;
    assert((len > 0) && (len <= MAXLEN));
    if ((1 == len) && ('0' == str[0]))
      len = 0;
    assert((0 == len) || (str[0] != '0'));

    
    pos = len;
    bit = 0;
    for (i = 0; i < N; i++)
    {
      if (scanf("%d", &K[i]) < 1)
        assert(0);
      assert((K[i] >= 0) && (K[i] <= MAXSUM));
      if (i < N-1)
      {
        A[i] = decode();
        assert((A[i] >= 0) && (A[i] <= MAXSUM));
      }
    }
    A[N-1] = decodelast();
    assert((A[N-1] >= 0) && (A[N-1] <= MAXSUM));
#ifndef NDEBUG
    {
      int ss1, ss2;
      int ii;
      ss1 = ss2 = 0;
      for (ii = 0; ii < N; ii++)
      {
        ss1 += A[ii];
        ss2 += K[ii];
      }
      assert(ss1 <= MAXSUM);
      assert(ss2 <= MAXSUM);
    }
#endif
    for (i = 0; i < N; i++)
    {
      A[i] += K[i];
    }

    sum = 0;
    for (i = 0; i < N-1; i++)
      sum += A[i];
    sum += N-1;

    bit = sum%4;
    bit = (4-bit)%4;
    val = A[N-1]&((1<<bit)-1);
    A[N-1] >>= bit;
    
    if (0 != A[N-1])
    {
      printf("%X", A[N-1]);
      nonzero = 1;
    }
    else
      nonzero = 0;
    for (i = N-2; i >= 0; i--)
    {
      shift(0);
      while (A[i]--)
        shift(1);
    }
    if (!nonzero)
      putchar('0');
    printf("\n");
  }

  return 0;
}
