/*
 * I Mistrzostwa Wielkopolski w Programowaniu Zespoowym
 * Rozwiazanie wzorcowe do zadania A - Funkcja
 * Autor: Rafal Jeziorny
 * Poznan, 2003
 */

#include <stdio.h>
#include <stdlib.h>
#define FOR(i,n) for(int i=0;i<n;i++)

char *A;
char *B;
int curA;
int curB;
int posA;
int posB;
#define MAX 10000000

bool GetBit (int &bit) {
    bit=0;
    if (curA<0) return 0;
    if (A[curA]<'A')   bit =  ( ( (A[curA]-'0') & (1 << (posA%4)) ) != 0 ? 1 : 0 );
    else               bit =  ( ( (A[curA]-'A'+10) & (1 << (posA%4)) ) != 0 ? 1 : 0 );
    if (!(++posA%4)) curA--;
    return 1;
}

void GetInt (int &Int) {
    Int=0;
    int ibit=0;
    int bit;
    while (GetBit(bit)) {
       if (bit) Int|=(1<<ibit);
       ibit++;
    }
}

void PutOne () {
    int curint;
    if (!(posB%4)) curint=0;
    else if (B[curB]<'A') curint =  B[curB]-'0';
         else             curint =  B[curB]-'A';
    curint|=(1<<(posB%4));
    if (curint<10) B[curB]='0'+curint;
    else B[curB]='A' + curint -10;
    if (!((++posB)%4)) curB--;
}

void PutZero () {
    if (!(posB%4)) B[curB]='0';
    if (!((++posB)%4)) curB--;
}

void PutInt (int Int) {
    FOR(i,32)  if (Int&(1<<i)) PutOne();
               else PutZero ();
}

int main () {
    A = new char [MAX];
    B = new char [MAX];
    char *ConstB=B;
    int d;
    scanf ("%d",&d);
    while (d--) {
        B=ConstB;
        int n;
        scanf("%d\n",&n);
        scanf ("%s\n",A);
        curA = strlen(A)-1;
        curB = MAX-1;
        B[curB]=0;
        posB = 0;
        posA = 0;
        int k;
        int bit;
        while (--n) {
            scanf("%d\n",&k);
            do {
                GetBit(bit);
                if (bit) k++;
            } while (bit);
            FOR(i,k) PutOne();
            PutZero();
        }
        scanf("%d\n",&k);
        int last;
        GetInt(last);
        PutInt(last+k);
        if (!(posB%4)) B[curB]='0';
        B = B + curB;
        while (B[0]=='0' && B[1]!=0) B++;
        printf("%s\n",B);
    }
    return 0;
}
