/*
 * I Mistrzostwa Wielkopolski w Programowaniu Zespoowym
 * Rozwiazanie wzorcowe do zadania D - Obzartuchy
 * Autor: Bartosz Nowierski
 * Poznan, 2003
 */

#define NDEBUG

#include <stdio.h>
#include <assert.h>

#define MAXN 10000
#define MAXT 100000
#define MAXM 1000000000

int main()
{
  int d;
  int N, i;
  int M;
  int sum;
  int t;

  
  if (scanf("%d", &d) < 1)
    assert(0);
  assert(d > 0);
  while (d--)
  {
    if (scanf("%d%d", &N, &M) < 2)
      assert(0);
    assert((N > 0) && (N <= MAXN));
    assert((M > 0) && (M <= MAXM));
    sum = 0;
    for (i = 0; i < N; i++)
    {
      if (scanf("%d", &t) < 1)
        assert(0);
      assert((t > 0) && (t <= MAXT));
      sum += (24*60*60)/t;
    }
    printf("%d\n", (sum+M-1)/M);
  }
  

  return 0;
}
