/*
 * I Mistrzostwa Wielkopolski w Programowaniu Zespoowym
 * Rozwiazanie wzorcowe do zadania F - Polki
 * Autor: Bartosz Nowierski
 * Poznan, 2003
 */

#define NDEBUG

#include <stdio.h>
#include <assert.h>

#define MAXN 1000
#define MAXK 250000


int P[2*MAXN-1], P2[2*MAXN-1];



int main()
{
  int d;
  int N, K;
  int ball;
  int i, k;
  

  if (scanf("%d", &d) < 1)
    assert(0);
  assert(d  > 0);

  while (d--)
  {
    if (scanf("%d%d", &N, &K) < 2)
      assert(0);
    assert((N >= 2) && (N <= MAXN));
    assert((K > 0) && (K <= MAXK));

    for (i = 0; i < 2*N-1; i++)
      P[i] = 0;
    for (i = 0; i < K-1; i++)
    {
      if (scanf("%d", &ball) < 1)
        assert(0);
      assert((ball >= 1) && (ball <= 2*N-1));
      P[ball-1]++;
    }
    if (scanf("%d", &ball) < 1)
      assert(0);
    assert((ball >= 1) && (ball <= 2*N-1));
    ball--;
    
    for (k = 0; k < N; k++)
    {
      for (i = k%2; i < 2*N-1; i += 2)
      {
        int dir;
        
        if (scanf("%d", &dir) < 1)
          assert(0);
        assert((-1 == dir) || (1 == dir));
        assert((i > 0) || (1 == dir));
        assert((i < 2*N-2) || (-1 == dir));

        if (0 == i)
          P[i+1] += P[i];
        else if (i == 2*N-2)
          P[i-1] += P[i];
        else
        {
          P[i+1] += P[i]/2;
          P[i-1] += P[i]/2;
          if (1 == P[i]%2)
          {
            P[i+dir]++;
            dir = -dir;
          }
        }
        P[i] = 0;
        if (i == ball)
          ball += dir;
        assert((ball >= 0) && (ball < 2*N-1));
      }
    }
    
    printf("%d\n", ball+1);
  }

  return 0;
}
