/*
 * I Mistrzostwa Wielkopolski w Programowaniu Zespoowym
 * Rozwiazanie wzorcowe do zadania H - Smiercionosne Jablka
 * Autor: Bartosz Nowierski
 * Poznan, 2003
 */

#define NDEBUG

#include <stdio.h>
#include <assert.h>

#define MAXV 1000
#define MAXN 100000
#define MAXA 250
#define MAXB 100
#define MAXC 20

#define INF 2000000000

int N;
int V;
int A[MAXN];
int B[MAXN];
int C[MAXN];


int main()
{
  int d;
  int i;
  int k;
  int min;
  

  if (scanf("%d", &d) < 1)
    assert(0);
  while (d--)
  {
    if (scanf("%d%d", &V, &N) < 2)
      assert(0);
    assert((V > 0) && (V <= MAXV));
    assert((N > 0) && (N <= MAXN));
    for (i = 0; i < N; i++)
    {
      if (scanf("%d%d%d", &A[i], &B[i], &C[i]) < 3)
        assert(0);
      assert((A[i] > 0 ) && (A[i] <= MAXA));
      assert((B[i] >= 0 ) && (B[i] <= MAXB));
      assert((C[i] >= 0 ) && (C[i] <= MAXC));
    }

    for (k = 0; k <= 20; k++)
    {
      min = INF;
      for (i = 0; i < N; i++)
      {
        if (A[i] < min)
          min = A[i];
        if (B[i] < 20)
        {
          B[i]++;
          A[i] += C[i];
        }
      }
      printf("%d: %d\n", k, min+5*V*V);
    }
  }

  return 0;
}
